#ifndef SMBZ_FIGHTERINFO_H
#define SMBZ_FIGHTERINFO_H

#include <string>
#include <vector>
#include <map>

class Engine;
class Player;

// a lot of this could be done much better...
// this may give you brain cancer. you've been warned

typedef void (*ActionCallback)(Engine* engine, Player* player, Player* other, bool guard);

struct FighterFrame
{
	int x, y, w, h, delay, rotate, scaleX, scaleY;
	int ox[2];
	int oy;
	ActionCallback onStart;
	ActionCallback onLoop;
};
typedef struct FighterFrame FighterFrame;

struct FighterAnim
{
	bool loop, breakthrough;
	std::string img;
	struct
	{
		bool on;
		std::string nextAnim;
		u32 frame;
	} combo;
	std::vector<FighterFrame> frames;
};
typedef struct FighterAnim FighterAnim;

struct FighterInfo
{
	std::string name;
	std::string dash;
	float speed;

	std::vector<std::string> sheets;
	std::vector<std::string> sounds;
	std::map<std::string, std::string> attacks;
	std::map<std::string, FighterAnim> anims;

	u32 frame;
	float delay;
	int loops;
	std::string anim;
};
typedef struct FighterInfo FighterInfo;

void loadActions();
ActionCallback getAction(std::string name);

#endif