#ifndef SMBZ_GAMECORE_H
#define SMBZ_GAMECORE_H

// ready for an aneurysm?
#include <ulib/ulib.h>
#include <map>
#include <string>
#include <vector>

typedef void (*Callback)(void *pUserData); // no std::function... kill me

struct Rect
{
	int x, y, w, h;
};
typedef struct Rect Rect;

struct BgFrame
{
	int x, y, w, h;
	int ox, oy, delay;
};
typedef struct BgFrame BgFrame;

struct BgAnim
{
	BgAnim() {frame = 0; delay = 0;}
	std::vector<BgFrame> frames;

	u32 frame;
	float delay;
};
typedef struct BgAnim BgAnim;

struct BgInfo
{
	std::string filename;
	UL_IMAGE* image;
	BgAnim anim;
	struct
	{
		int w, h;
		int colors[4];
	} rect;
	bool isRect;
	int offsetX, offsetY;
	int sepX, sepY;
	float paraX, paraY;
	float scrollX, scrollY;
	float scrollPosX, scrollPosY;
	bool tileX, tileY, scale;
	struct
	{
		bool on;
		int top, left, bottom, right;
	} bordercolor;
};
typedef struct BgInfo BgInfo;

#endif