#ifndef SMBZ_MAINMENU_H
#define SMBZ_MAINMENU_H

#include <stdio.h>
#include <nds.h>
#include <mp3_shared.h>
#include <ulib/ulib.h>

#include "gamecore.h"

class UI;

class Mainmenu
{
public:
	void init(UI* ui, bool firsttime=true);
	void deinit();

	void destroy();
	void switchUI(UI* which, bool fade=false, bool firsttime=false);

	void tick();
	void draw();


	bool isStarted() {return started;}
	UL_IMAGE* imgField;
	UL_IMAGE* logo;
	UL_IMAGE* button;
	volatile wav_stuffs* titleselect;
	volatile wav_stuffs* sndselect;
	float logoX, logoScale;
	int fadeAlpha, fadeAdd;
	std::string selectedChars[2];
	std::string selectedStage;
	std::vector<FILELIST> charList;
	std::vector<FILELIST> stageList;

private:
	bool started;
	UI* m_ui;

	UI* switchTo;
	bool switchFirstTime;
};

#endif