/*
    Copyright 2008-2013 Risike, Reylak, MicroLua's developers

    This file is part of MicroLua.

    MicroLua is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MicroLua is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MicroLua.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MICROCPP_VARS_H
#define MICROCPP_VARS_H

#include <nds.h>
#include <ulib/ulib.h>

// The same value as in ds_timer.c
#define TIMER_ID 0

#define ULUA_VERSION "4.7.3"
#if defined(MICROLUA_MP3) && defined(MICROLUA_WIFI)
	#ifdef MICROLUA_NITROFS
		#define ULUA_VARIATION "mp3wifi-nitro"
	#else
		#define ULUA_VARIATION "mp3wifi"
	#endif
#elif defined(MICROLUA_MP3)
	#ifdef MICROLUA_NITROFS
		#define ULUA_VARIATION "mp3-nitro"
	#else
		#define ULUA_VARIATION "mp3"
	#endif
#else
	#define MICROLUA_WIFI
	#ifdef MICROLUA_NITROFS
		#define ULUA_VARIATION "maxmod-nitro"
	#else
		#define ULUA_VARIATION "maxmod"
	#endif
#endif

#define SCREEN_WIDTH 256
#define SCREEN_HEIGHT 192

#define TO_RAM  0
#define TO_VRAM  1

#define SCREEN_UP 1
#define SCREEN_DOWN 0

#define ALPHA_RESET 100

#define LED_ON PM_LED_ON
#define LED_SLEEP PM_LED_SLEEP
#define LED_BLINK PM_LED_BLINK

#define ATTR_X1 0
#define ATTR_Y1 1
#define ATTR_X2 2
#define ATTR_Y2 3
#define ATTR_X3 4
#define ATTR_Y3 5
#define ATTR_COLOR 6
#define ATTR_COLOR1 7
#define ATTR_COLOR2 8
#define ATTR_COLOR3 9
#define ATTR_COLOR4 10
#define ATTR_TEXT 11
#define ATTR_VISIBLE 12
#define ATTR_FONT 13
#define ATTR_IMAGE 14
#define ATTR_X4 15
#define ATTR_Y4 16

#define MAX_OBJECTS 10000

#define PLAY_LOOP 0
#define PLAY_ONCE 1

#define KEY_A 0x1
#define KEY_B 0x2
#define KEY_SELECT 0x4
#define KEY_START 0x8
#define KEY_RIGHT 0x10
#define KEY_LEFT 0x20
#define KEY_UP 0x40
#define KEY_DOWN 0x80
#define KEY_R 0x100
#define KEY_L 0x200
#define KEY_X 0x400
#define KEY_Y 0x800
#define KEY_TOUCH 0x1000
#define KEY_LID 0x2000

extern int SCREEN_UP_DISPLAY;
extern int SCREEN_DOWN_DISPLAY;
extern int spaceBetweenScreens;
extern bool dualScreen;
extern bool lcdSwapped;

extern int alphaGroup;

extern bool canDraw(int scrn);

typedef struct mapObj{
    UL_IMAGE * image;
    unsigned short * table;
    int width, height;
    int tileWidth, tileHeight;
    int scrollX, scrollY;
    int spaceX, spaceY;
} MapObj;

#endif
