#ifndef SMBZ_UI_H
#define SMBZ_UI_H

#include <ulib/ulib.h>

#include "mainmenu.h"

struct Button
{
	int x, y;
	std::string text;
	Callback callback;
	void *pUserData;

	void setCallback(Callback newAction, void *pUser) {callback = newAction; pUserData = pUser;}
};
typedef struct Button Button;

class UI
{
public:
	virtual ~UI() {}
	virtual void init(Mainmenu* mainmenu, bool firsttime=true) = 0;
	virtual void destroy() = 0;

	virtual void tick() = 0;
	virtual void draw() = 0;

protected:
	Mainmenu* m_mainmenu;
};

#endif