#ifndef SMBZ_TITLEUI_H
#define SMBZ_TITLEUI_H

#include <ulib/ulib.h>

#include "ui.h"

struct CharFrame
{
	int x, y, w, h;
	int ox, oy, delay;
};
typedef struct CharFrame CharFrame;

struct CharAnim
{
	std::vector<CharFrame> frames;
};
typedef struct CharAnim CharAnim;

struct CharInfo
{
	CharInfo() {frame = 0; delay = 0;}
	std::map<std::string, CharAnim> anims;

	// current animation info
	std::string anim;
	u32 frame;
	float delay;
};
typedef struct CharInfo CharInfo;

class TitleUI : public UI
{
public:
	void init(Mainmenu* mainmenu, bool firsttime=true);
	void destroy();

	void tick();
	void draw();

	static void onPlay(void *pUserData);
	static void onQuit(void *pUserData);

private:
	int scrollX[2], fade, fadeAdd, animTicks;
	float textZoom;
	int drawMenu, currAnim, btn, scaleAdd;
	UL_IMAGE* ground;
	std::vector<std::pair<UL_IMAGE*, CharInfo> > charSprites; // kill me now...
	std::vector<int> spriteOffsets;
	Button buttons[2];
};

#endif